fs = 48e3;
% オーディオデータの読み込み %
[audio_in, fs_audio] = audioread("VSQSE_965_cat_6.wav");
% 片chのみ抽出 %
audio = audio_in(:,1);
%　サンプリングレートを48kHzに変換、末尾に2秒の無音を付加　%
audio = [resample(audio,48e3,fs_audio);zeros(2*48e3,1) ];

% パラメータ(遅延時間) %
tau1 = 39.85e-3;
tau2 = 36.10e-3;
tau3 = 33.27e-3;
tau4 = 30.15e-3;
tau5 = 5.0e-3;
tau6 = 1.7e-3;

% 遅延サンプル数 %
delay_sample_c1 = round(tau1*48e3);
delay_sample_c2 = round(tau2*48e3);
delay_sample_c3 = round(tau3*48e3);
delay_sample_c4 = round(tau4*48e3);
delay_sample_a1 = round(tau5*48e3);
delay_sample_a2 = round(tau6*48e3);

% パラメータ(フィードバックゲイン) %
g1 = 0.871402;
g2 = 0.882762;
g3 = 0.891443;
g4 = 0.901117;
g5 = 0.7;
g6 = 0.7;

%パラメータ(直接音と残響音のゲイン)%
D = 1;
E = 0.3;

% 伝達関数(コムフィルタ)r % 
b_c1 = [zeros( 1,delay_sample_c1 ) 1];
a_c1 = [1 zeros(1,delay_sample_c1 - 1) -g1];
b_c2 = [zeros( 1,delay_sample_c2 ) 1];
a_c2 = [1 zeros(1,delay_sample_c2 - 1) -g2];
b_c3 = [zeros( 1,delay_sample_c3 ) 1];
a_c3 = [1 zeros(1,delay_sample_c3 - 1) -g3];
b_c4 = [zeros( 1,delay_sample_c4 ) 1];
a_c4 = [1 zeros(1,delay_sample_c4 - 1) -g4];

% 伝達関数(オールパスフィルタ) %
b_a1 = [-g5 zeros( 1,delay_sample_a1 - 1 ) 1];
a_a1 = [1 zeros(1,delay_sample_a1 - 1) -g5];
b_a2 = [-g6 zeros( 1,delay_sample_a2 - 1 ) 1];
a_a2 = [1 zeros(1,delay_sample_a2 - 1) -g6];

% コムフィルタ(C1～C4)の出力を演算 %
c1 = filter( b_c1, a_c1, audio );
c2 = filter( b_c2, a_c2, audio );
c3 = filter( b_c3, a_c3, audio );
c4 = filter( b_c4, a_c4, audio );

% オールパスフィルタ(a1～a2)の出力を演算 %
a1 = filter( b_a1, a_a1, c1 + c2 + c3 + c4 );
a2 = filter( b_a2, a_a2, a1 );

soundsc( E*a2 + D*audio, 48e3, 16);
audiowrite("cat_schroeder_reverb.wav",E*a2 + D*audio, fs_audio);
